<?
/*
	Dawgclan Network counter
	Rothgar, 13/01/04	
	In order to use or distribute this script,
	this copyright information must not be modified.
*/

// Configuration.
// Path to data files,
// Incase you want to hide your visitors ip's.
$dcc_dir = $_SERVER["DOCUMENT_ROOT"] . "/counter/";
$dcc_log_file = $dcc_dir . "visitors.log";
$dcc_hit_file = $dcc_dir . "hits.log";

// Path to counter's images.
// Images must be numbered 0-9,
// with extension $dcc_ext.
$dcc_img_dir = "counter/";
$dcc_ext = "gif";

// Counter expiration in minutes.
// Will not relog visitor for x minutes.
$dcc_expire = 60;

// Debug mode (Do not enable unless you need help.)
// This will print ip addresses and various other information.
$debug = 0;



// Do not edit below this comment unless you know what you are doing.
// Functions for script.

function counter($images=0, $type=0)
{
	// $type is TRUE for unique, or FALSE for total hits.
	global $HTTP_COOKIE_VARS, $dcc_log_file, $dcc_hit_file, $dcc_expire;

	$client_ip = $_SERVER["HTTP_X_FORWARDED_FOR"];
	$logged = false;

	if (trim($client_ip) == "")
		$client_ip = $_SERVER["REMOTE_ADDR"];

	if ($HTTP_COOKIE_VARS['dc_counter'])
	{
		$logged = true;
		counter_debug("Cookie is set, no need to log.<br />");
	}

	else
	{
		// try and set cookie.
		setcookie("dc_counter", "Logged on counter", time()+($dcc_expire * 60), "/", $_SERVER["HTTP_HOST"]);

		// Read and discard expired entries.
		$dcc_visitors = array(); // Array for ip addresses.
		$cur_time = floor(time()/60);

		$dcc_lines = array();
		if (file_exists($dcc_log_file))
		{
			if ( !($fp = fopen($dcc_log_file, "rt")) )
				counter_debug("Could not open counter log file for reading.<br />");
			while (!feof($fp))
			{
				$line = fgets($fp,256);
				$dcc_lines[] = $line;
			}
			fclose($fp);
		}

		foreach ($dcc_lines as $visitor)
		{
			$tempdata = explode("|", $visitor);
			if (($cur_time - $tempdata[1]) < $dcc_expire)
				$dcc_visitors[$tempdata[0]] = chop($tempdata[1]); // Has not expired.
		}

		if ($dcc_visitors[$client_ip])
		{
			counter_debug("$client_ip already logged, user is not unique.<br />");
			counter_debug("Time left until expiration: " . ($dcc_expire - ($cur_time - $dcc_visitors[$client_ip])) . "minutes.<br />");
			$logged = true;
		}
		else
		{
			counter_debug("$client_ip is not logged, user is unique.<br />");
			$dcc_visitors[$client_ip] = floor(time()/60);
			$logged = false;
		}

		counter_debug("Current logged visitors:<br />");
		if ($GLOBALS['debug'])
			print_r($dcc_visitors);
		counter_debug("<br /><br />");

		// Re-write log file.
		// Open log file for writing.
		if( !($fp = fopen($dcc_log_file, "wt")) )
			counter_debug("Could not open counter log file for writing.<br />");

		foreach($dcc_visitors as $ip => $timestamp)
			fwrite($fp, "$ip|$timestamp\n");

		fclose($fp);
	}

	if ( (!$fp = fopen($dcc_hit_file, "a+t")) ) // Open hit file for reading and writing.
		counter_debug("Could not open counter hit file for reading and writing.<br />");

	flock($fp, 1); // Lock for reading.
	$hit_line = fgets($fp, 256);
	$hits = explode("|", $hit_line);
	if ($logged)
	{
		$hits[0] = $hits[0] == "" ? 1 : $hits[0];
		$hits[1]++;
	}
	else
	{
		$hits[0]++;
		$hits[1]++;
	}

	flock($fp, 2); // Lock for writing.
	ftruncate($fp, 0);
	fwrite($fp, "$hits[0]|$hits[1]");

	flock($fp, 3);
	fclose($fp);

	if ($type)
		counter_print($images, $hits[0]);
	else
		counter_print($images, $hits[1]);
}

function counter_print($images=0, $hits="0")
{
	global $dcc_img_dir, $dcc_ext;
	if ($images)
		for ($i = 0; $i < strlen($hits); $i++)
		{
			$num = substr($hits,$i,1);
			print("<img src=\"$dcc_img_dir$num.$dcc_ext\" alt=\"$num\">");
		}
	else
		print($hits);
}

function counter_debug($string)
{
	global $debug;

	if ($debug)
		print($string);
}
?>
